// Copyright 1998-2000 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.
//
// $Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniAIAT/OAIIndex.h,v 1.5 2000/01/19 23:36:21 kc Exp $

#import <Foundation/NSObject.h>
#import "OAIIndexDelegateProtocol.h"

@interface OAIIndex : NSObject
{
    void *nonretainedCorpus;
    /*" The nonretainedCorpus is owned by the native AIAT index which we deallocate in our -dealloc method.  This reference is kept as an ivar so we can communicate the OAIIndex delegate to the OAICorpus. "*/

    id<OAIIndexDelegateProtocol, NSObject> delegate;

    void *index;
    void *storage;
}

- initNewIndex:(NSString *)filename forDirectory:(NSString *)directory;
- initWithIndex:(NSString *)filename forDirectory:(NSString *)directory;

- (void)update;
- (void *)indexObject;

// Delegate
- (void)setDelegate:(id<OAIIndexDelegateProtocol, NSObject>)aDelegate;
- (id<OAIIndexDelegateProtocol>)delegate;

@end
