// Copyright 1998-1999 Omni Development, Inc.  All rights reserved.
//
// This software may only be used and reproduced according to the
// terms in the file OmniSourceLicense.html, which should be
// distributed with this project and can also be found at
// http://www.omnigroup.com/DeveloperResources/OmniSourceLicense.html.

extern "C" {
    #import "OAIObjCTokenizerHolder.h"
    #import "OAIStringScanner.h"
    #import <OmniBase/rcsid.h>
    #import <OmniBase/macros.h>
}

RCS_ID("$Header: /Network/Source/CVS/OmniGroup/Frameworks/OmniAIAT/OAIObjCTokenizerHolder.M,v 1.5 1999/10/18 00:34:26 luke Exp $")

#import "OAIObjCTokenizer.h"

@implementation OAIObjCTokenizerHolder

- initWithFactory:(id <OAITokenizer>)factory;
{
    if (!(self = [super init]))
        return nil;

    tokenizerFactory = [factory retain];

    return self;
}

- (void)dealloc;
{
    [tokenizerFactory release];
    [super dealloc];
}

- (void *)cppTokenizerForStream:(void *)stream;
{
    OAIStringScanner *scanner;
    OAIObjCTokenizer *tokenizer;

    OMNI_POOL_START {
        scanner = [[OAIStringScanner alloc] initWithStream:stream];
        tokenizer = new OAIObjCTokenizer([tokenizerFactory tokenizerForScanner:scanner]);
        [scanner release];
    } OMNI_POOL_END;

    return tokenizer;
}

@end
